<?php
// $Id: fast_gallery.inc,v 1.3 2008/07/09 17:41:10 rapsli Exp $
class FastGallery {

  /**
   * We are going the information to the db
   * so it can be faster processed later on
   */
  function updateDb($ar_files, $parent = 'top') {
    
    $value = '';
    foreach ($ar_files as $key => $value) {
      if(!is_array($value)){
        $folder = $this->getFolderInPath($value);
      }
      if (is_array($value)) { //is a subfolder
        $this->updateDb($value,$folder);
      } else {
        $sql = "SELECT gid FROM {fast_gallery} WHERE path = '%s'";
        //print 'insert '.$value.'<br/>';
        $result = db_query($sql, $value);
        if (!db_fetch_array($result)) { //there's no entry in the db for this file
          $sql = "INSERT INTO {fast_gallery} " .
          "(path,folder,parent) " .
          "VALUES ('%s','%s','%s')";
          db_query($sql, $value, $folder, $parent);
        }
      }
    }
  }

  /**
   * Find the pics that are not in the filesystem anymore
   * and delete them from the db.
   */
  function deletePics() {
    $arPics = $this->getPicsFlat();
    foreach ($arPics as $value) {
      if (!file_exists($value->path)) {
        $sql = "DELETE FROM {fast_gallery} WHERE gid = %d";
        db_query($sql, $value->gid);
      }
    }
  }
  
  function clearGallery(){
    db_query("TRUNCATE TABLE {fast_gallery}");
  }

  /**
   * Get only the pics from a folder, but then also list all the
   * child folders as albums so there is going to be a hierarchy
   */
  function getPicsHierarchy($folder='') {
    $result = pager_query(db_rewrite_sql("SELECT path,folder FROM {fast_gallery} WHERE folder = '$folder'"),
                    variable_get('fast_gallery_nr_per_page', 30));
    $picBag = array();
    while($row = db_fetch_object($result)){
      $picBag[] = $row;
      $parent = $row->folder;
    }
    //get the folders
    $result = db_query("SELECT path,folder FROM {fast_gallery} " .
                                         "WHERE parent = '%s' GROUP BY folder",$folder);
    while($row = db_fetch_object($result)){
      $row->isFolder = true;
      array_unshift($picBag,$row);
    }
    return $picBag;
  }

  /**
  * Fetch all the pics from the db
  * It's just going to be one big list
  * @return array
  */
  function getPicsFlat() {
    $sql = "SELECT gid,path FROM {fast_gallery}";
    $result = db_query($sql);
    $picBag = array ();
    while ($row = db_fetch_object($result)) {
      $picBag[] = $row;
    }
    return $picBag;
  }

  /**
  * Get all images on a given directory
  *
  * @param $path
  *  String. The absolute path to start the scanner
  * @param $path
  *  Boolean. TRUE for recursive scanning
  * @return
  *  Array. All images' paths
  */
  function exploreDir($path = '', $recursive = FALSE) {

    /*$arTmp = explode("",$path);
    if($arTmp[count($arTmp)-1] != "/"){
      $arTmp[count($arTmp)] = "/";
    }*/

    // A list of image extensions. It should be on lower and
    // upper cases to work on non GNU systems, like Solaris and Windows
    $exts = array (
      'png',
      'gif',
      'jpeg',
      'jpg',
      'bmp',
      'PNG',
      'GIF',
      'JPEG',
      'JPG',
      'BMP'
    );

    // Get all files from a given path
    //$files = array ();
    $files["$path"] = array ();
    foreach ($exts as $ext) {
      //$files["$path"][] = glob("$path*.$ext");
      $files["$path"] = array_merge($files["$path"], glob("$path*.$ext"));
    }

    // If its a recursive scan, enter in all directories
    // and scan for more image files
    if ($dirs = glob("$path*", GLOB_ONLYDIR) and !empty ($recursive)) {
      foreach ($dirs as $dir) {
        
        $files["$path"] = array_merge($files["$path"], $this->exploreDir("$dir/",true));
      }
    }
    
    return $files;
  }
  
  /**
   * we get a path like my/path/test.jpg
   * So this would then extract the folder in which
   * test.jpg is -> in this example this would be path
   */
  public function getFolderInPath($path,$i=0){
    $arTmp = explode("/", $path);
    $folder = $arTmp[count($arTmp) - (2+$i)];
    return $folder;
  }
}